import java.awt.BorderLayout;
import javax.swing.JPanel;
import java.awt.Dimension;

import javax.swing.DefaultListModel;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.JSeparator;
import javax.swing.filechooser.FileNameExtensionFilter;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Base.SBPKCS12;
import SecureBlackbox.Base.SBStrUtils;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElFileCertStorage;
import SecureBlackbox.Base.TElMemoryCertStorage;
import SecureBlackbox.Base.TElRelativeDistinguishedName;
import SecureBlackbox.Base.TElWinCertStorage;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.MIME.TAnsiStringMIMEStream;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;

public class MimeViewer_OptionsSMime extends MimeViewer_PlugControl {
	private static final long serialVersionUID = 1L;
	private JList<CertificateElement> lvCert;
	private JCheckBox cbCustCert;
	
	public static boolean UseWinCertStorage = true;
	public static boolean UseUserCertStorage = true;

	private final String sDefCertPswdInCustStorage = "{37907B5C-B309-4AE4-AFD2-2EAE948EADA2}";
	
	public MimeViewer_OptionsSMime() {
		setLayout(new BorderLayout(0, 0));
		
		JPanel panel = new JPanel();
		panel.setPreferredSize(new Dimension(10, 30));
		add(panel, BorderLayout.NORTH);
		panel.setLayout(null);
		
		cbCustCert = new JCheckBox("Use Custom certificates");
		cbCustCert.setSelected(true);
		cbCustCert.setBounds(6, 7, 165, 23);
		panel.add(cbCustCert);
		
		cbWinCert = new JCheckBox("Use windows certificates");
		cbWinCert.setBounds(177, 7, 304, 23);
		panel.add(cbWinCert);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setPreferredSize(new Dimension(500, 4));
		add(scrollPane, BorderLayout.WEST);
		
		lvCert = new JList<CertificateElement>();
		lvCert.setModel(new DefaultListModel<CertificateElement>());
		scrollPane.setViewportView(lvCert);
		
		JPanel panel_1 = new JPanel();
		add(panel_1, BorderLayout.CENTER);
		panel_1.setLayout(null);
		
		JButton btnAddCert = new JButton("Add Certificate");
		btnAddCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addCertClick();
			}
		});
		btnAddCert.setBounds(10, 11, 148, 23);
		panel_1.add(btnAddCert);
		
		JButton btnDeleteCert = new JButton("Delete Certificate");
		btnDeleteCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteCertClick();
			}
		});
		btnDeleteCert.setBounds(10, 40, 148, 23);
		panel_1.add(btnDeleteCert);
		
		JButton btnSaveCert = new JButton("Save Certificate");
		btnSaveCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveCertificate();
			}
		});
		btnSaveCert.setBounds(10, 68, 148, 23);
		panel_1.add(btnSaveCert);
		
		JButton btnViewCert = new JButton("View Details");
		btnViewCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				viewDetailsClick();
			}
		});
		btnViewCert.setBounds(10, 96, 148, 23);
		panel_1.add(btnViewCert);
		
		JButton btnLoadStorage = new JButton("Load Storage");
		btnLoadStorage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					loadStorageClick();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		btnLoadStorage.setBounds(10, 134, 148, 23);
		panel_1.add(btnLoadStorage);
		
		JButton btnSaveStorage = new JButton("Save Storage");
		btnSaveStorage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					saveStorageClick();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		btnSaveStorage.setBounds(10, 162, 148, 23);
		panel_1.add(btnSaveStorage);
		
		JSeparator separator = new JSeparator();
		separator.setBounds(10, 126, 148, 3);
		panel_1.add(separator);
		
		try {
			init();
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	public static TElFileCertStorage UserCertStorage = null;
	public static TElMemoryCertStorage CurCertStorage = null;
	private JCheckBox cbWinCert;

	private void init() throws Exception {
		UserCertStorage = new TElFileCertStorage();
		CurCertStorage = new TElMemoryCertStorage();

		cbCustCert_CheckedChanged();
		cbWinCert_CheckedChanged();
		
		// Load default user storage
		LoadStorage("CerStorageDef.ucs");
		LoadStorage("..\\..\\CerStorageDef.ucs");
	}

	private void cbWinCert_CheckedChanged() {
		UseWinCertStorage = cbWinCert.isSelected();
	}

	private void cbCustCert_CheckedChanged()
	{
		UseUserCertStorage = cbCustCert.isSelected();		
	}

	public void LoadStorage(String sFileName) throws Exception
	{
		UserCertStorage = null;
		UserCertStorage = new TElFileCertStorage();

		File fi = new File(sFileName);
		if (!fi.exists())
			return;

		TAnsiStringMIMEStream sm = new TAnsiStringMIMEStream();
		sm.loadFromFile(sFileName);
		try
		{
			sm.setPosition(0);
			CheckSBB(UserCertStorage.loadFromBufferPFX(sm.getMemory(), sDefCertPswdInCustStorage),
					 "Cannot load certificates from file storage: '" + sFileName + "'");

			RepaintCertificates();
		}
		finally
		{
			sm.Free();
		}
	}

	public void SaveStorage(String sFileName) throws Exception
	{
		TAnsiStringMIMEStream sm = new TAnsiStringMIMEStream();
		try
		{
			TSBInteger iSize = new TSBInteger();
			byte [] buffer = null;
			int iError = UserCertStorage.saveToBufferPFX(buffer, iSize, sDefCertPswdInCustStorage, SBConstants.SB_ALGORITHM_PBE_SHA1_3DES, SBConstants.SB_ALGORITHM_PBE_SHA1_3DES);

			if ((iError != SBPKCS12.SB_PKCS12_ERROR_BUFFER_TOO_SMALL) || (iSize.value <= 0))
				CheckSBB(iError, "SaveToBufferPFX failed to save the storage");

			sm.setLength(iSize.value);
			buffer = sm.getMemory();
			CheckSBB(UserCertStorage.saveToBufferPFX(buffer, iSize, sDefCertPswdInCustStorage, SBConstants.SB_ALGORITHM_PBE_SHA1_3DES, SBConstants.SB_ALGORITHM_PBE_SHA1_3DES), "SaveToBufferPFX failed to save the storage");
			sm.setMemory(buffer, buffer.length);
			sm.saveToFile(sFileName);
		}
		finally
		{
			sm.Free();
		}
	}
	
	public static void CheckSBB(int iErrorCode, String sErrorMessage) throws Exception
	{
		if (iErrorCode != 0)
			throw new Exception(sErrorMessage + ". Error code: '" + iErrorCode + "'.");
	}
	
	private void RepaintCertificates()
	{
		try
		{
			DefaultListModel<CertificateElement> model = ((DefaultListModel<CertificateElement>)lvCert.getModel());
			model.removeAllElements();

			int i;
			String s;
			TElX509Certificate cer;
			for (i = 0; i < UserCertStorage.getCount(); i++)
			{
				cer = UserCertStorage.getCertificate(i);
				s = GetOIDValue(cer.getSubjectRDN(), SBConstants.SB_CERT_OID_COMMON_NAME.Data) + " / " + 
					GetOIDValue(cer.getSubjectRDN(), SBConstants.SB_CERT_OID_EMAIL.Data);
				model.addElement(new CertificateElement(s, cer));
			}
		}
		finally
		{
		}
	}

	public String GetCaption()
	{
		return "SMIME Options";
	}

	public static String GetOIDValue(TElRelativeDistinguishedName RDN, byte[] S)
	{
		String t = "";
		int iCount = RDN.getCount();
		for (int i = 0; i < iCount; i++)
		{
			if (SBUtils.compareContent(RDN.getOID(i), S))
			{
				if (t != "")
					t += " / ";

				t += SBStrUtils.utf8ToStr(RDN.getValue(i));
			}
		}

		return t;
	}
	
	protected void saveStorageClick() throws Exception {
		String fileName = getSaveUcsFileName();
		if (fileName.length() > 0)
			SaveStorage(fileName );
	}

	private String getSaveUcsFileName() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("Users Certificates Storage (*.ucs)", "ucs");
	    fc.setFileFilter(filter);		
	
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected void loadStorageClick() throws Exception {
		String fileName = getOpenUcsFileName();
		if (fileName.length() > 0)
			LoadStorage(fileName);
	}

	private String getOpenUcsFileName() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("Users Certificates Storage (*.ucs)", "ucs");
	    fc.setFileFilter(filter);		
	
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected void viewDetailsClick() {
		if (lvCert.getSelectedIndices().length <= 0)
			return;

		MimeViewer_CertDetails CertInfo = new MimeViewer_CertDetails();
		try
		{
			TElX509Certificate cer = (TElX509Certificate)((CertificateElement)((DefaultListModel<CertificateElement>)lvCert.getModel()).get(0)).getTag();
			CertInfo.SetCertificate(cer);
			CertInfo.setVisible(true);
		}
		finally
		{
			CertInfo.dispose();
		}
	}

	protected void saveCertificate() {
		if ((lvCert.getSelectedIndices().length <= 0))
			return;

		String fileName = getSaveFileName();
		if (fileName.length() > 0)
		{
			TAnsiStringMIMEStream sm = new TAnsiStringMIMEStream();
			TElX509Certificate cer;
			try
			{
				cer = (TElX509Certificate)((CertificateElement)((DefaultListModel<CertificateElement>)lvCert.getModel()).get(0)).getTag();

				boolean SavePrivateKey = true;
				String sPwd = requestPassphrase();
				if (cer.getPrivateKeyExists())
				{
					if (sPwd.length() == 0)
						SavePrivateKey = false;
				}

				if (SavePrivateKey)
				{
					cer.saveToStreamPFX(sm, sPwd, SBConstants.SB_ALGORITHM_PBE_SHA1_RC4_128, SBConstants.SB_ALGORITHM_PBE_SHA1_RC4_128);
					sm.saveToFile(fileName);
				}
				else
				{
					cer.saveToStream(sm);
					sm.saveToFile(fileName);
					if (cer.getPrivateKeyExists())
						showMessage("Saved without private key", "MIME Viewer");
				}

			}
			finally
			{
				sm.Free();
			}
		}
	}

	private String getSaveFileName() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("Certificates (*.bin)", "bin");
	    fc.setFileFilter(filter);		
	
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected void deleteCertClick() {
		if (lvCert.getSelectedIndices().length <= 0)
			return;

		TElX509Certificate cer;
		int idx;
		int i;
		int[] inds = lvCert.getSelectedIndices();
		for (i = 0; i < inds.length; i++)
		{
			cer = (TElX509Certificate)((CertificateElement)((DefaultListModel<CertificateElement>)lvCert.getModel()).get(i)).getTag();
			if (cer != null) 
			{
				idx = UserCertStorage.indexOf(cer);
				UserCertStorage.remove(idx);
			}
		}

		RepaintCertificates();
	}

	private String requestPassphrase() {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please enter password", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}
	
	protected void addCertClick() {
		String fileName = getOpenFile();

		if (fileName.length() > 0 )
		{		
			String sPwd = requestPassphrase();
			TElX509Certificate cer = new TElX509Certificate();
			
			if (cer.loadFromFileAuto(fileName, sPwd) != 0)
				showMessage("Error loading the certificate", "MIME Viewer");
			else
			{
				int idx = UserCertStorage.indexOf(cer);
				if ((idx >= 0) && (cer.getPrivateKeyExists()) && (!UserCertStorage.getCertificate(idx).getPrivateKeyExists()))
				{
					UserCertStorage.remove(idx);
					idx = -1;
				}

				if (idx < 0)
				{
					UserCertStorage.add(cer, true);

					RepaintCertificates();
				}
				else
					showMessage("Certificate is already in the list.", "MIME Viewer");
			}

		}
	}
	
	private void showMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.INFORMATION_MESSAGE);
	}

	private String getOpenFile() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("Certificates (*.pfx;*.p7b;*.cer;*.bin)", "pfx", "p7b", "cer", "bin");
	    fc.setFileFilter(filter);		
	
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";

	}
	
	public static void SMIMECollectCertificates()
	{
		TElWinCertStorage WinStorage;

		CurCertStorage.clear();

		if (UseWinCertStorage)
		{
			WinStorage = new TElWinCertStorage();
			try
			{
				WinStorage.getSystemStores().add("MY");
				WinStorage.exportTo(CurCertStorage);
			}
			finally
			{
				WinStorage.Free();
			}
		}
		
		if (UseUserCertStorage)
		{
			UserCertStorage.exportTo(CurCertStorage);
		}
	}
}
