import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.JCheckBox;
import javax.swing.JButton;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Office.TElOfficeCustomSignatureHandler;
import SecureBlackbox.Office.TElOfficeOpenXMLSignedPart;
import SecureBlackbox.Office.TElOfficeOpenXMLSignedRelationshipPart;
import SecureBlackbox.Office.TElOfficePackagePart;
import SecureBlackbox.XMLSecurity.SBXMLSec;

import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;


public class SignedPartsInfoForm extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTable lvInfo;
	private JTextArea tbInfo;
	private JCheckBox cbShowAllParts;
	private PartsTableModel model;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					SignedPartsInfoForm dialog = new SignedPartsInfoForm();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public SignedPartsInfoForm() {
		setTitle("Signed Parts Info");
		setBounds(100, 100, 527, 379);
		getContentPane().setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 11, 499, 136);
		getContentPane().add(scrollPane);
		
		model = new PartsTableModel();
		lvInfo = new JTable();
		model.addTableModelListener(new TableModelListener() {
			
			public void tableChanged(TableModelEvent e) {
				lvInfo_SelectedIndexChanged();
			}
		});
		lvInfo.setFillsViewportHeight(true);
		scrollPane.setViewportView(lvInfo);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 158, 499, 152);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblContentType = new JLabel("Content Type");
		lblContentType.setBounds(10, 11, 127, 14);
		panel.add(lblContentType);
		
		JLabel lblDigestMethod = new JLabel("Digest Method");
		lblDigestMethod.setBounds(10, 36, 204, 14);
		panel.add(lblDigestMethod);
		
		JLabel lblRelationshipPartInfo = new JLabel("Relationship Part Info");
		lblRelationshipPartInfo.setBounds(10, 61, 236, 14);
		panel.add(lblRelationshipPartInfo);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(10, 86, 479, 55);
		panel.add(scrollPane_1);
		
		tbInfo = new JTextArea();
		scrollPane_1.setViewportView(tbInfo);
		
		dlbContentType = new JLabel(" ");
		dlbContentType.setBounds(145, 11, 344, 14);
		panel.add(dlbContentType);
		
		dlbDigestMethod = new JLabel(" ");
		dlbDigestMethod.setBounds(145, 36, 344, 14);
		panel.add(dlbDigestMethod);
		
		cbShowAllParts = new JCheckBox("Show All Parts");
		cbShowAllParts.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				cbShowAllParts_CheckedChanged();
			}
		});
		cbShowAllParts.setBounds(10, 322, 125, 23);
		getContentPane().add(cbShowAllParts);
		
		JButton btnNewButton = new JButton("OK");
		btnNewButton.setBounds(418, 322, 91, 23);
		getContentPane().add(btnNewButton);

	}

    TElOfficeCustomSignatureHandler _Handler = null;
    private JLabel dlbContentType;
    private JLabel dlbDigestMethod;

    public void SetSignatureHandler(TElOfficeCustomSignatureHandler handler)
    {
        _Handler = handler;
        UpdateParts();
    }

    private void UpdateParts()
    {
        model.clear();
        model.fill(_Handler, cbShowAllParts.isSelected());
    }

    private void cbShowAllParts_CheckedChanged()
    {
        UpdateParts();
    }

    private void lvInfo_SelectedIndexChanged()
    {
        dlbContentType.setText("");
        dlbDigestMethod.setText("");
        tbInfo.setText("");
        if (lvInfo.getSelectedRowCount() == 0)
            return;

        Object tag = model.getTag(lvInfo.getSelectedRow());
        if (tag == null)
            return;

        if (tag instanceof TElOfficeOpenXMLSignedPart)
        {
            TElOfficeOpenXMLSignedPart SignedPart = (TElOfficeOpenXMLSignedPart)tag;
            dlbContentType.setText(SignedPart.getContentType());
            dlbDigestMethod.setText(SBConstants.getAlgorithmNameByAlgorithm(SBXMLSec.digestMethodToHashAlgorithm(SignedPart.getDigestMethod())));
            if (SignedPart instanceof TElOfficeOpenXMLSignedRelationshipPart)
            {
                TElOfficeOpenXMLSignedRelationshipPart SignedRelPart = (TElOfficeOpenXMLSignedRelationshipPart)SignedPart;
                String s = "Part URI: " + SignedRelPart.getPartURI() + "\r\n";
                if (SignedRelPart.getSourceTypeCount() > 0)
                {
                    s = s + "Source Types: " + "\r\n";
                    for (int i = 0; i < SignedRelPart.getSourceTypeCount(); i++)
                        s = s + " - " + SignedRelPart.getSourceType(i) + "\r\n";
                }

                if (SignedRelPart.getSourceIdCount() > 0)
                {
                    s = s + "Source Ids: ";
                    for (int i = 0; i < SignedRelPart.getSourceIdCount(); i++)
                        s = s + SignedRelPart.getSourceId(i) + ", ";
                }

                tbInfo.setText(s);
            }
        }
        else if (tag instanceof TElOfficePackagePart)
        {
            dlbContentType.setText(((TElOfficePackagePart)tag).getContentType());
        }
    }
}
