import java.awt.Component;
import java.net.URL;
import javax.swing.DefaultListCellRenderer;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;

import SecureBlackbox.PGP.SBPGPConstants;

public class IconListRenderer extends DefaultListCellRenderer {

	private static final long serialVersionUID = 1L;

	@Override
	public Component getListCellRendererComponent(JList<?> list, Object value, int index,
		boolean isSelected, boolean cellHasFocus) {

		JLabel label =
			(JLabel) super.getListCellRendererComponent(list,
				value, index, isSelected, cellHasFocus);

		ListData data = (ListData)value;
		
        int alg = data.Keys.getSecretKeys(data.Index).getPublicKeyAlgorithm();
		if ((alg == SBPGPConstants.SB_PGP_ALGORITHM_PK_RSA) ||
			(alg == SBPGPConstants.SB_PGP_ALGORITHM_PK_RSA_SIGN) ||
			(alg == SBPGPConstants.SB_PGP_ALGORITHM_PK_RSA_ENCRYPT)) 
		{
			label.setIcon(getIcon("dkey"));
		} 
		else 
		{
			label.setIcon(getIcon("ekey"));
		}		

		return label;
	}
	
	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".ico");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}
}
