

import java.awt.EventQueue;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.SBSocket;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElFileStream;
import SecureBlackbox.Base.TElSocket;
import SecureBlackbox.Base.TElStringList;
import SecureBlackbox.Base.TNotifyEvent;
import SecureBlackbox.Base.TSBBoolean;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.Base.TSBString;
import SecureBlackbox.SFTPClient.*;
import SecureBlackbox.SFTPCommon.*;
import SecureBlackbox.SSHClient.*;
import SecureBlackbox.SSHCommon.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTextField editHost;
	private JTextField editUser;
	private JPasswordField editPassword;
	private JTextField editKey;
	private JTable table;
	private JTextField editInfo;
	private boolean btnConnectTag;
	private JButton btnConnect;
	private JTextArea memoLog;
	
	private static int FILE_BLOCK_SIZE				= 65280;
	private static int STATE_OPEN_DIRECTORY_SENT	= 1;
	private static int STATE_READ_DIRECTORY_SENT	= 2;
	private static int STATE_CHANGE_DIR				= 3;
	private static int STATE_MAKE_DIR				= 4;
	private static int STATE_RENAME					= 5;
	private static int STATE_REMOVE					= 6;
	private static int STATE_DOWNLOAD_OPEN			= 7;
	private static int STATE_DOWNLOAD_RECEIVE		= 8;
	private static int STATE_UPLOAD_OPEN			= 9;
	private static int STATE_UPLOAD_SEND			= 10;
	private static int STATE_CLOSE_HANDLE			= 11;

	private TElSocket scktClient;
	private TElSSHClient sshClient;
	private TElSSHTunnelList tunnelList;
	private TElSubsystemSSHTunnel sftpTunnel; 
	private TElSftpClient sftpClient;

	private int state;
	private ArrayList<TElSftpFileInfo> currentFileList = new ArrayList<TElSftpFileInfo>();
	private byte[] currentHandle;
	private long currentFileSize = 0;
	private String currentDir;
	private String relDir;

	private byte[] receiveBuf = new byte[8192];
	private TSBInteger receiveLen = new TSBInteger();

	private TElFileStream currentFile;
	
	private ProgressDialog progress;
	private TElSSHMemoryKeyStorage keyStorage;

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("Sftp demo");
		setResizable(false);
		setBounds(100, 100, 559, 632);
		getContentPane().setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Connection properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 533, 117);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblHost = new JLabel("Host");
		lblHost.setBounds(10, 34, 51, 14);
		panel.add(lblHost);
		
		JLabel lblUsername = new JLabel("Username");
		lblUsername.setBounds(10, 59, 65, 14);
		panel.add(lblUsername);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(10, 87, 65, 14);
		panel.add(lblPassword);
		
		editHost = new JTextField();
		editHost.setText("127.0.0.1");
		editHost.setBounds(71, 31, 147, 20);
		panel.add(editHost);
		editHost.setColumns(10);
		
		editUser = new JTextField();
		editUser.setText("test");
		editUser.setBounds(71, 56, 147, 20);
		panel.add(editUser);
		editUser.setColumns(10);
		
		editPassword = new JPasswordField();
		editPassword.setText("test");
		editPassword.setBounds(71, 84, 147, 20);
		panel.add(editPassword);
		
		btnConnect = new JButton("Connect");
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				connectClick();
			}
		});
		btnConnect.setBounds(228, 33, 161, 23);
		panel.add(btnConnect);
		
		JLabel lblPrivateKeyFile = new JLabel("Private key file for PUBLICKEY authentication:");
		lblPrivateKeyFile.setBounds(228, 62, 253, 14);
		panel.add(lblPrivateKeyFile);
		
		editKey = new JTextField();
		editKey.setText("d:\\test\\ssh.key");
		editKey.setBounds(228, 84, 253, 20);
		panel.add(editKey);
		editKey.setColumns(10);
		
		JButton btnBrowse = new JButton("...");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				editKey.setText(getOpenFileName());
			}
		});
		btnBrowse.setBounds(491, 83, 30, 23);
		panel.add(btnBrowse);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 163, 533, 271);
		getContentPane().add(scrollPane);
		
		table = new JTable(new FilesTableModel());
		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2){
					changeDirClick();
				}			
			}
		});
		table.setFillsViewportHeight(true);
		scrollPane.setViewportView(table);
		
		editInfo = new JTextField();
		editInfo.setBounds(10, 445, 533, 20);
		getContentPane().add(editInfo);
		editInfo.setColumns(10);
		
		JButton btnMakeDir = new JButton("MakeDir");
		btnMakeDir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				makeDirClick();
			}
		});
		btnMakeDir.setBounds(10, 476, 81, 23);
		getContentPane().add(btnMakeDir);
		
		JButton btnRename = new JButton("Rename");
		btnRename.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				renameClick();
			}
		});
		btnRename.setBounds(95, 476, 81, 23);
		getContentPane().add(btnRename);
		
		JButton btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteClick();
			}
		});
		btnDelete.setBounds(180, 476, 81, 23);
		getContentPane().add(btnDelete);
		
		JButton btnGetFile = new JButton("Get File");
		btnGetFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				getFileClick();
			}
		});
		btnGetFile.setBounds(265, 476, 81, 23);
		getContentPane().add(btnGetFile);
		
		JButton btnPutFile = new JButton("Put File");
		btnPutFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				putClick();
			}
		});
		btnPutFile.setBounds(350, 476, 81, 23);
		getContentPane().add(btnPutFile);
		
		JButton btnUpdateInfo = new JButton("Update Info");
		btnUpdateInfo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				updateClick();
			}
		});
		btnUpdateInfo.setBounds(435, 476, 108, 23);
		getContentPane().add(btnUpdateInfo);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(10, 510, 533, 86);
		getContentPane().add(scrollPane_1);
		
		memoLog = new JTextArea();
		scrollPane_1.setViewportView(memoLog);
		
		editPath = new JTextField();
		editPath.setBounds(10, 132, 533, 20);
		getContentPane().add(editPath);
		editPath.setColumns(10);
		
		init();
	}
	
	protected void changeDirClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected");
			return;
		}

		if (table.getSelectedRowCount() > 0)
		{
			int row = table.getSelectedRow();
			FilesTableModel model = (FilesTableModel)table.getModel();
			TElSftpFileInfo info = model.getSelectedRowTag(row);
			
			if (info.getAttributes().getDirectory())
			{
				editInfo.setText("");
				changeDir(info.getName());
			}
		}		
	}

	protected void updateClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		if (table.getSelectedRowCount() == 0)
		{
			log("File is not selected.");
			return;
		}

		int row = table.getSelectedRow();
		FilesTableModel model = (FilesTableModel)table.getModel();
		TElSftpFileInfo info = model.getSelectedRowTag(row);
		
		log(String.format("Requesting  download, \"%s\"", info.getName()));
		sftpClient.requestAttributes(absPath(info.getName()), false);
	}

	protected void putClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		String fileName = getOpenFileName();
		
		if (fileName.length() > 0)
			uploadFile(fileName);		
	}

	protected void getFileClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		if (table.getSelectedRowCount() == 0)
		{
			log("File is not selected.");
			return;
		}

		int row = table.getSelectedRow();
		FilesTableModel model = (FilesTableModel)table.getModel();
		TElSftpFileInfo info = model.getSelectedRowTag(row);
		
		if (info.getAttributes().getDirectory())
		{
			log("Can not download directory. Please choose ordinary file.");
			return;
		}
            
		String fileName = getSaveFileName();
		
		if (fileName.length() > 0)
			downloadFile(info, fileName);
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 

	protected void deleteClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		if (table.getSelectedRowCount() == 0)
		{
			log("File is not selected.");
			return;
		}

		if (showConfirmMessage("Do you really want to remove this item?", getTitle()))
			return;

		int row = table.getSelectedRow();
		FilesTableModel model = (FilesTableModel)table.getModel();
		TElSftpFileInfo info = model.getSelectedRowTag(row);
		
		if (info.getAttributes().getDirectory())
			deleteDir(info.getName());
		else
			deleteFile(info.getName());
	}

	private boolean showConfirmMessage(String msg, String cap) {
		return (JOptionPane.showConfirmDialog(this, msg, cap, JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION);
	}

	protected void renameClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		if (table.getSelectedRowCount() == 0)
		{
			log("File is not selected.");
			return;
		}

		int row = table.getSelectedRow();
		FilesTableModel model = (FilesTableModel)table.getModel();
		TElSftpFileInfo info = model.getSelectedRowTag(row);

			
		String newName = inputDialog("Enter NEW name:");

		if (newName.length() == 0) 
		{
			log("Invalid filename, renaming cancelled.");
			return;
		}

		renameFile(info.getName(), newName);		
	}

	protected void makeDirClick() {
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		String DirName = inputDialog("Enter directory name:");

		if (DirName.length() == 0) 
		{
			log("Invalid directory name, creation cancelled.");
			return;
		}
		makeDir(DirName);
	}

	private String inputDialog(String msg) {
		JTextField jpf = new JTextField();
		JOptionPane.showConfirmDialog(this, jpf, msg, JOptionPane.OK_CANCEL_OPTION);
		return jpf.getText();
	}

	protected void connectClick() {
		if (btnConnectTag == true)
		{
			closeConnection();
		}
		else
		{
            scktClient = new TElSocket();
            
			try
			{
				scktClient.setAddress(editHost.getText());
				scktClient.setPort(22);
				
				keyStorage.clear();
				TElSSHKey key = new TElSSHKey();
				boolean privateKeyAdded = false;
				if (editKey.getText().length() > 0)
				{
					TSBString pwd = new TSBString();
					if (prompt("Enter password for private key:", false, pwd))
					{
						int err = key.loadPrivateKey(editKey.getText(), pwd.value);
						if (err == 0)
						{
							keyStorage.add(key);
							int authType = sshClient.getAuthenticationTypes();
							authType |= SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY;
							sshClient.setAuthenticationTypes(authType);
							privateKeyAdded = true;
						}
						else
						{
							log("Private key file could not be loaded due to error " + err);
						}
					}
				}

				if (!privateKeyAdded)
				{
					int authType = sshClient.getAuthenticationTypes();
					authType &= ~(SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY);
					sshClient.setAuthenticationTypes(authType);
				}

				beginConnect();
			}
			catch(Exception ex)
			{
				showErrorMessage(ex);
				return;
			}
		}		
	}

	private void beginConnect() {
		try
		{
	  		if (scktClient.connect(5000) == 0) {
				log("TCP connection opened.");
				btnConnectTag = true;
				btnConnect.setText("Disconnect");            
				sshClient.setUserName(editUser.getText());
				sshClient.setPassword(new String(editPassword.getPassword()));
				sshClient.open();
							
				Thread t = new  Thread(new Runnable() {
					
					public void run() {
						beginReceive();			
					}
				});
				
				t.start();
	  		} else {
	  			log("Failed to connect socket to the port");
	  		}
		}
		catch(Exception ex)
		{
			scktClient.close(false);
			scktClient = null;
			showErrorMessage(ex);
			return;
		}
	}

	private void beginReceive() {
		try
		{	
			if (isClientSocketConnected())
			{
				if (scktClient.canReceive(10000))
					scktClient.receive(receiveBuf, receiveBuf.length, receiveLen);
				
				if (receiveLen.value == 0)
				{
					showErrorMessage("Connection lost");
					closeConnection();
					return;
				}
	
				while (receiveLen.value > 0)
				{
					sshClient.dataAvailable();
				}
				
				beginReceive();
			}
		}
		catch(Exception ex)
		{
			if (isClientSocketConnected())
			{
				showErrorMessage(ex);
				closeConnection();
			}
		}
	}

	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 
	
	private void init()
	{
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		btnConnectTag = false;

		sshClient = new TElSSHClient();
		
		sshClient.setVersions(SBSSHCommon.sbSSH2);

		initSSHEvents();
		
		tunnelList = new TElSSHTunnelList();
		sftpTunnel = new TElSubsystemSSHTunnel();
		sftpClient = new TElSftpClient();
		sftpTunnel.setTunnelList(tunnelList);
		sshClient.setTunnelList(tunnelList);
		sftpClient.setTunnel(sftpTunnel);
		
		initSFTPEvents();
		
		keyStorage = new TElSSHMemoryKeyStorage();
		sshClient.setKeyStorage(keyStorage);
	}

	private void initSFTPEvents() {
		sftpClient.setOnOpenConnection(new TNotifyEvent(sftpOnOpenConnection));
		sftpClient.setOnCloseConnection(new TNotifyEvent(sftpOnCloseConnection));
		sftpClient.setOnOpenFile(new TSBSftpFileOpenEvent(sftpOnOpenFile));
		sftpClient.setOnError(new TSBSftpErrorEvent(sftpOnError));
		sftpClient.setOnSuccess(new TSBSftpSuccessEvent(sftpOnSuccess));
		sftpClient.setOnDirectoryListing(new TSBSftpDirectoryListingEvent(sftpOnDirectoryListing));
		sftpClient.setOnData(new TSBSftpDataEvent(sftpOnData));
		sftpClient.setOnAbsolutePath(new TSBSftpAbsolutePathEvent(sftpOnAbsolutePath));
		sftpClient.setOnFileAttributes(new TSBSftpFileAttributesEvent(sftpOnFileAttributes));
	}

	private void initSSHEvents() {
		sshClient.setOnSend(new TSSHSendEvent(sshOnSend));
		sshClient.setOnReceive(new TSSHReceiveEvent(sshOnReceive));
		sshClient.setOnOpenConnection(new TSSHOpenConnectionEvent(sshOnOpenConnection));
		sshClient.setOnCloseConnection(new TSSHCloseConnectionEvent(sshOnCloseConnection));
		sshClient.setOnAuthenticationSuccess(new TNotifyEvent(sshOnAuthenticationSuccess));
		sshClient.setOnAuthenticationFailed(new TSSHAuthenticationFailedEvent(sshOnAuthenticationFailed));
		sshClient.setOnAuthenticationKeyboard(new TSSHAuthenticationKeyboardEvent(sshOnAuthenticationKeyboard));
		sshClient.setOnError(new TSSHErrorEvent(sshOnError));
		sshClient.setOnKeyValidate(new TSSHKeyValidateEvent(sshOnKeyValidate));
	}
	
	TSSHKeyValidateEvent.Callback sshOnKeyValidate = new TSSHKeyValidateEvent.Callback() {
		
		public void tsshKeyValidateEventCallback(TObject sender, TElSSHKey serverKey, TSBBoolean accept) {
			log("Server key received");
			accept.value = true; // NEVER do this. 
		}
	};
	
	TSSHErrorEvent.Callback sshOnError = new TSSHErrorEvent.Callback() {
		
		public void tsshErrorEventCallback(TObject sender, int errorCode) {
			log("SSH error " + errorCode);
			log("If you have ensured that all connection parameters are correct and you still can't connect,");
			log("please contact EldoS support as described on http://www.eldos.com/sbb/support-tech.php");
			log("Remember to provide details about the error that happened.");
			if (sshClient.getServerSoftwareName().length() > 0)
			{
				log("Server software identified itself as: " + sshClient.getServerSoftwareName());
			}
		}
	};
	
	TSSHAuthenticationKeyboardEvent.Callback sshOnAuthenticationKeyboard = new TSSHAuthenticationKeyboardEvent.Callback() {
		
		public void tsshAuthenticationKeyboardEventCallback(TObject sender,
				TElStringList prompts, boolean[] echo, TElStringList responses) {
			responses.clear();
			for (int i = 0; i < prompts.getCount(); i++)
			{
				TSBString response = new TSBString();				
				if (prompt((String) prompts.get(i), echo[i], response))
					responses.add(response.value);
				else
					responses.add("");
			}
		}
	};
	
	private boolean prompt(String cap, boolean echo, TSBString response) {
		int result;
		if (echo)
		{
			JTextField jpf = new JTextField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = jpf.getText();
		} else {
			JPasswordField jpf = new JPasswordField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = new String(jpf.getPassword());				
		}

		return (result == 0);
	}

	TSSHAuthenticationFailedEvent.Callback sshOnAuthenticationFailed = new TSSHAuthenticationFailedEvent.Callback() {
		
		public void tsshAuthenticationFailedEventCallback(TObject sender, int authenticationType) {
			log(String.format("Authentication type %d failed.", authenticationType));
		}
	};
	
	TNotifyEvent.Callback sshOnAuthenticationSuccess = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			log("Authentication succeeded.");
		}
	};
	
	TSSHCloseConnectionEvent.Callback sshOnCloseConnection = new TSSHCloseConnectionEvent.Callback() {
		
		public void tsshCloseConnectionEventCallback(TObject sender) {
			log("SSH Connection closed.");			
		}
	};
	
	TSSHOpenConnectionEvent.Callback sshOnOpenConnection = new TSSHOpenConnectionEvent.Callback() {
		
		public void tsshOpenConnectionEventCallback(TObject sender) {
			log("SSH Connection started.");
		}
	};
	
	TSSHReceiveEvent.Callback sshOnReceive = new TSSHReceiveEvent.Callback() {
		
		public void tsshReceiveEventCallback(TObject sender, byte[] buffer, int maxSize, TSBInteger written) {
			written.value = Math.min(maxSize, receiveLen.value);
			if (written.value > 0) 
			{
                buffer = Arrays.copyOf(receiveBuf, written.value);
                int rest = receiveLen.value - written.value;
                if (rest > 0)
                	receiveBuf = Arrays.copyOf(receiveBuf, rest);
                int receive = receiveLen.value;
				receive -= written.value;
				receiveLen.value = receive;
			}
		}
	};
	
	TSSHSendEvent.Callback sshOnSend = new TSSHSendEvent.Callback() {
		
		public void tsshSendEventCallback(TObject sender, byte[] buffer) {
			try
			{
				scktClient.send(buffer, 0, buffer.length, new TSBInteger());
			}
			catch(Exception ex)
			{
				if (isClientSocketConnected())
				{
					showErrorMessage(ex);
					closeConnection();
				}
			}
		}
	};
	
	TSBSftpFileAttributesEvent.Callback sftpOnFileAttributes = new TSBSftpFileAttributesEvent.Callback() {
		
		public void tsbSftpFileAttributesEventCallback(TObject sender,
				TElSftpFileAttributes Attributes) {

			if (table.getSelectedRowCount() == 0) return;
			
			int row = table.getSelectedRow();
			FilesTableModel model = (FilesTableModel)table.getModel();
			TElSftpFileInfo info = model.getSelectedRowTag(row);

			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saSize) > 0)
				info.getAttributes().setSize(Attributes.getSize());
			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saUID) > 0)
				info.getAttributes().setUID(Attributes.getUID());
			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saGID) > 0)
				info.getAttributes().setGID(Attributes.getGID());
			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saATime) > 0)
				info.getAttributes().setATime(Attributes.getATime());
			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saMTime) > 0)
				info.getAttributes().setMTime(Attributes.getMTime());
			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saExtended) > 0)
			{
				for(int i = 0; i < Attributes.getExtendedAttributeCount(); i++) 
				{
					int j = info.getAttributes().addExtendedAttribute();
					info.getAttributes().getExtendedAttribute(j).setExtType(Attributes.getExtendedAttribute(i).getExtType());
					info.getAttributes().getExtendedAttribute(j).setExtData(Attributes.getExtendedAttribute(i).getExtData());
				}
			}
            
			info.getAttributes().setDirectory(Attributes.getDirectory());
			if ((Attributes.getIncludedAttributes() & SBSftpCommon.saPermissions) > 0)
			{
				info.getAttributes().setUserRead(Attributes.getUserRead());
				info.getAttributes().setUserWrite(Attributes.getUserWrite());
				info.getAttributes().setUserExecute(Attributes.getUserExecute());
				info.getAttributes().setGroupRead(Attributes.getGroupRead());
				info.getAttributes().setGroupWrite(Attributes.getGroupWrite());
				info.getAttributes().setGroupExecute(Attributes.getGroupExecute());
				info.getAttributes().setOtherRead(Attributes.getOtherRead());
				info.getAttributes().setOtherWrite(Attributes.getOtherWrite());
				info.getAttributes().setOtherExecute(Attributes.getOtherExecute());
			}
			model.changeRow(info, row);
		}
	};
	
	TSBSftpAbsolutePathEvent.Callback sftpOnAbsolutePath = new TSBSftpAbsolutePathEvent.Callback() {
		
		public void tsbSftpAbsolutePathEventCallback(TObject sender, String path) {
			currentDir = path;
			buildFileList(currentDir);
            editPath.setText(path);
		}
	};
	
	TSBSftpDataEvent.Callback sftpOnData = new TSBSftpDataEvent.Callback() {
		
		public void tsbSftpDataEventCallback(TObject sender, byte[] Buffer) {
			if (currentFile == null)
				return;
			if (state == STATE_DOWNLOAD_RECEIVE)
			{
				currentFile.write(Buffer, 0, Buffer.length);
				if (currentFile.getPosition() >= currentFileSize)
				{
					currentFile.Free();
					currentFile = null;
					closeProgressWindow();
					log("File received");
					closeCurrentHandle();
				}
				else
				{
					sftpClient.read(currentHandle, currentFile.getPosition(), FILE_BLOCK_SIZE);
					setProgressBarValue((int)(100 * currentFile.getPosition() / currentFileSize));
				}
			}			
		}
	};
	
	private void closeProgressWindow()
	{
		if (progress != null)
		{
			progress.dispose();
			progress = null;
		}
	}

	private void setProgressBarValue(int val)
	{
		if (progress != null)
			progress.setProgressBarValue(val);
	}
	
	TSBSftpDirectoryListingEvent.Callback sftpOnDirectoryListing = new TSBSftpDirectoryListingEvent.Callback() {
		
		public void tsbSftpDirectoryListingEventCallback(TObject sender,
				TElSftpFileInfo[] listing) {
			TElSftpFileInfo fileInfo;
			if (state == STATE_READ_DIRECTORY_SENT)
			{
				for (int i = 0; i < listing.length; i++)
				{
					fileInfo = new TElSftpFileInfo();
					listing[i].copyTo(fileInfo);
					currentFileList.add(fileInfo);
				}
				sftpClient.readDirectory(currentHandle);
			}
		}
	};
	TSBSftpSuccessEvent.Callback sftpOnSuccess = new TSBSftpSuccessEvent.Callback() {
		
		public void tsbSftpSuccessEventCallback(TObject sender, String comment) {
			if (state == STATE_CHANGE_DIR)
			{
				log(String.format("Operation succeeded with comment \"%s\"", comment));
				requestAbsolutePath(absPath(relDir) + '/');
			}
			else if (state == STATE_MAKE_DIR || 
				state == STATE_RENAME ||
				state == STATE_REMOVE)
			{
				log(String.format("Operation succeeded with comment \"%s\"", comment));
				buildFileList(currentDir);
			}
			else if (state == STATE_UPLOAD_SEND)
			{
				if (progress != null)
					setProgressBarValue((int)(100 * currentFile.getPosition() / currentFileSize));
				writeNextBlockToFile();
			}
			else if (state == STATE_CLOSE_HANDLE)
			{
				if (currentFile != null)
				{
					currentFile.Free();
					currentFile = null;
				}
				buildFileList(currentDir);
			}
		}
	};
	
	TSBSftpErrorEvent.Callback sftpOnError = new TSBSftpErrorEvent.Callback() {
		
		public void tsbSftpErrorEventCallback(TObject sender, int errorCode, String comment) {
			if (state == STATE_READ_DIRECTORY_SENT &&
					errorCode == SBSftpCommon.SSH_ERROR_EOF)
				{
					log("File list received.");
					closeCurrentHandle();
					outputFileList();
				}
				else if (state == STATE_DOWNLOAD_RECEIVE && 
					errorCode == SBSftpCommon.SSH_ERROR_EOF)
				{
					log("File received.");
					if (currentFile != null)
					{
						currentFile.Free();
						currentFile = null;
					}
				}
	            else
	                log(String.format("Error %d with comment \"%s\".", errorCode, comment));  
		}
	};
	TSBSftpFileOpenEvent.Callback sftpOnOpenFile = new TSBSftpFileOpenEvent.Callback() {
		
		public void tsbSftpFileOpenEventCallback(TObject sender, byte[] Handle) {
			if (state == STATE_OPEN_DIRECTORY_SENT)
			{
				log("Directory opened.");
				currentHandle = Handle;
				sftpClient.readDirectory(currentHandle);
				state = STATE_READ_DIRECTORY_SENT;
			}
			else if (state == STATE_CHANGE_DIR)
			{
				sftpClient.closeHandle(Handle);
			}
			else if (state == STATE_DOWNLOAD_OPEN)
			{
				currentHandle = Handle;
				showProgressWindow();
				sftpClient.read(Handle, currentFile.getPosition(), FILE_BLOCK_SIZE);
				state = STATE_DOWNLOAD_RECEIVE;
			}
			else if (state == STATE_UPLOAD_OPEN)
			{
				currentHandle = Handle;
				showProgressWindow();
				writeNextBlockToFile();
				state = STATE_UPLOAD_SEND;
			}
		}
	};
			
	private void showProgressWindow()
	{
		if (progress != null)
			progress.dispose();
		progress = new ProgressDialog(this);
		progress.setVisible(true);
	}
	
	TNotifyEvent.Callback sftpOnOpenConnection = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			log("Sftp connection started.");
			currentDir = ".";
			editPath.setText(currentDir);
			buildFileList(".");
		}
	};
	
	TNotifyEvent.Callback sftpOnCloseConnection = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			log("Sftp connection closed.");
			closeConnection();
		}
	};
	private JTextField editPath;
	
	// methods
	
	private void closeConnection()
	{
		if (isClientSocketConnected())
		{
			log("TCP connection closed.");
			scktClient.close(false);
			scktClient = null;
			clearFilesTable();
			editKey.setText("");
            editInfo.setText("");
			if (currentFile != null)
			{
				try
				{
					currentFile.Free();
				}
				catch(Exception ex)
				{}
				currentFile = null;
			}
		}
		
		btnConnectTag = false;
		btnConnect.setText("Connect");
	}

	private boolean isClientSocketConnected() {
		if (scktClient == null) return false;
		return scktClient.getState() == SBSocket.issConnected;
	}

	private void clearFilesTable() {
		((FilesTableModel)table.getModel()).clear();
	}

	private void closeCurrentHandle()
	{
		if (isClientSocketConnected())
		{
			log("Closing active handle.");
			sftpClient.closeHandle(currentHandle);
		} else
			log("Error: not connected.");
	}

	private boolean requestAbsolutePath(String path)
	{
		return sftpClient.requestAbsolutePath(path);
	}

	private void outputFileList()
	{
		clearFilesTable();
		FilesTableModel model = (FilesTableModel)table.getModel();
		for (int i = 0; i < currentFileList.size(); i++)
		{	
			TElSftpFileInfo fi = (TElSftpFileInfo)currentFileList.get(i);
			model.addRow(fi);
		}
	}

	private void writeNextBlockToFile()
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
        
		if (currentFile.getPosition() >= currentFileSize)
		{
			state = STATE_CLOSE_HANDLE;
			if (progress != null)
				progress.dispose();
			closeCurrentHandle();
			return;
		}

		byte[] buf = new byte[FILE_BLOCK_SIZE];
		int transferred;

		transferred = currentFile.read(buf, 0, (int)FILE_BLOCK_SIZE);
		byte[] wb = null;
		if (transferred < FILE_BLOCK_SIZE)
		{
			wb = new byte[transferred];
			wb = Arrays.copyOf(buf, transferred);
		}
		else
			wb = buf;
		buf = null;
		sftpClient.write(currentHandle, currentFile.getPosition() - transferred, wb);
	}

	private void buildFileList(String path)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
		currentFileList.clear();
		log("Opening directory " + path);
		sftpClient.openDirectory(path);
		state = STATE_OPEN_DIRECTORY_SENT;
	}

	protected void log(String text)
	{
		String time = new Date().toString();
		StringBuilder sb = new StringBuilder(time.length() + 2 + text.length() + 2);
		if (memoLog.getText().length() > 0)
			sb.append("\r\n");
		sb.append(time);
		sb.append(": ");
		sb.append(text);
		memoLog.setText(sb.toString());
	}
	private void changeDir(String dir)
	{
		log("Trying to change directory to " + dir);
		relDir = dir;
		state = STATE_CHANGE_DIR;
		sftpClient.openDirectory(absPath(dir));
	}

	private void makeDir(String dir)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}

		log("Creating directory " + dir);
		TElSftpFileAttributes attrs = new TElSftpFileAttributes();
		state = STATE_MAKE_DIR;
		sftpClient.makeDirectory(absPath(dir), attrs);
	}

	private void renameFile(String oldName, String newName)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
		
		log(String.format("Renaming \"%s\" to \"%s\"", 
			oldName, newName));
		state = STATE_RENAME;
		sftpClient.renameFile(absPath(oldName), absPath(newName));
	}

	private void deleteDir(String name)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
		log("Removing directory " + name);
		state = STATE_REMOVE;
		sftpClient.removeDirectory(absPath(name));
	}         

	private void deleteFile(String name)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
		log("Removing file " + name);
		state = STATE_REMOVE;
		sftpClient.removeFile(absPath(name));
	}


	private void downloadFile(TElSftpFileInfo info, String localName)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
        
		try
		{
			currentFile = new TElFileStream(localName, "rw", true);
			currentFileSize = info.getAttributes().getSize();
		}
		catch(Exception ex)
		{
			currentFileSize = 0;
			log(String.format("Failed to download the file: \"%s\", errror: \"%s\"", info.getName(), ex.getMessage()));
			return;
		}
	
		log("Starting file download " + info.getName());
		state = STATE_DOWNLOAD_OPEN;
		sftpClient.openFile(
			absPath(info.getName()),
			SBSftpCommon.fmRead, null);
	}

	private void uploadFile(String localFile)
	{
		if (!isClientSocketConnected())
		{
			log("Error: not connected.");
			return;
		}
		
		String fName = "";
		try
		{
			File fi = new File(localFile);
			fName = fi.getName();
			currentFileSize = fi.length();
			currentFile = new TElFileStream(localFile, "r", true);
		}
		catch(Exception ex)
		{
			showErrorMessage(ex);
			return;
		}

		log(String.format("Starting file upload, \"%s\"", localFile));
		state = STATE_UPLOAD_OPEN;
		sftpClient.createFile(absPath(fName));
	}

	protected void showErrorMessage(Exception ex)
	{
		ex.printStackTrace();
		JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
	}

	protected void showErrorMessage(String message)
	{
		JOptionPane.showMessageDialog(null, message, "Error", JOptionPane.ERROR_MESSAGE);
	}
	
	public String absPath(String strFileName)
	{
		String strResult = "";
		
		char lastSymbol = currentDir.charAt(currentDir.length() - 1);
		
		if ((currentDir.length() == 0) ||
			(lastSymbol != '\\' && lastSymbol != '/'))
		{
			strResult = currentDir + '/' + strFileName;
		}
		else strResult = currentDir + strFileName;

		return strResult;
	}
	
	public void onClosingProgressDialog()
	{
		closeCurrentHandle();
		currentFile.Free();
		currentFile = null;
		closeProgressWindow();
		log("Transfer aborted");
	}
}
