import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import javax.swing.JDialog;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import SecureBlackbox.Base.*;
import SecureBlackbox.SSHServer.*;



public class SettingsFrm extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTable table;

	private TElSimpleSSHServer serv; 
	
	public SettingsFrm() {
		setTitle("Server Settings");
		setBounds(100, 100, 566, 293);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Autorized users", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(10, 10, 538, 200);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JButton btnAdd = new JButton("Add");
				btnAdd.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						addUserClick();
					}
				});
				btnAdd.setBounds(437, 22, 91, 23);
				panel.add(btnAdd);
			}
			{
				JButton btnRemove = new JButton("Remove");
				btnRemove.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						removeUserClick();
					}
				});
				btnRemove.setBounds(437, 52, 91, 23);
				panel.add(btnRemove);
			}
			{
				JScrollPane scrollPane = new JScrollPane();
				scrollPane.setBounds(10, 22, 424, 170);
				panel.add(scrollPane);
				{
					table = new JTable(new UserTableModel());
					table.setFillsViewportHeight(true);
					scrollPane.setViewportView(table);
				}
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
		}
	}

	protected void addUserClick() {
		AddUserDialog dlg = new AddUserDialog();
		dlg.setModal(true);
		dlg.setVisible(true);
		if (dlg.IsOk)
			serv.getUsers().addSSHUser(dlg.edUserName.getText(), dlg.tbPass.getText(), null);
		FillUsers();		
	}

	protected void removeUserClick() {
		
		UserTableModel model = (UserTableModel)table.getModel();
		serv.getUsers().deleteUser(model.getUserName(table.getSelectedRow()));
		FillUsers();
	}

	
	// sets up users list view according to user accounts settings
	private void FillUsers()
	{
		clearUserTable();
		serv.getUsers().lock();
		try{
		for (int i = 0; i < serv.getUsers().getCount(); i++)
		{
			TElCustomUser user = serv.getUsers().getUsers(i);
			UserTableModel model = (UserTableModel) table.getModel();
			model.addRow(user);
		}	}
		finally
		{serv.getUsers().unlock();}
	}

	private void clearUserTable() {
		UserTableModel model = (UserTableModel) table.getModel();
		model.clear();
	}
	
	// forces settings update 
	public static void ChangeSettings(TElSimpleSSHServer Serv)
	{
		SettingsFrm frm = new SettingsFrm();
		frm.serv = Serv;
		frm.FillUsers();
		frm.setModal(true);
		frm.setVisible(true);
	}

}