

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.SwingConstants;
import javax.swing.JTextField;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JPasswordField;
import javax.swing.JButton;
import javax.swing.border.TitledBorder;
import javax.swing.table.TableColumn;

import SecureBlackbox.Base.SBUtils;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Date;


public class Main extends JDialog implements ConnectionEventListener {

	private static final long serialVersionUID = 1L;
	private JTextField tbHost;
	private JTextField tbUsername;
	private JPasswordField tbPassword;
	private JTextField tbRemoteHost;
	private JTable table;
	private JTable tableLog;
	private JSpinner tbPort;
	private JSpinner tbRemotePort;
	private SshSession session = null;
	private JButton btnStart;


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setResizable(false);
		setTitle("SSH local port forwarding demo application");
		setBounds(100, 100, 761, 514);
		getContentPane().setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(0, 0, 234, 487);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblSshSettings = new JLabel("SSH Settings");
		lblSshSettings.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		lblSshSettings.setHorizontalAlignment(SwingConstants.CENTER);
		lblSshSettings.setBackground(Color.GRAY);
		lblSshSettings.setBounds(10, 11, 192, 14);
		panel.add(lblSshSettings);
		
		JLabel lblServerSettings = new JLabel("Server address:");
		lblServerSettings.setBounds(10, 36, 129, 14);
		panel.add(lblServerSettings);
		
		tbHost = new JTextField();
		tbHost.setText("192.168.0.1");
		tbHost.setBounds(10, 51, 115, 20);
		panel.add(tbHost);
		tbHost.setColumns(10);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(149, 36, 46, 14);
		panel.add(lblPort);
		
		tbPort = new JSpinner();
		tbPort.setModel(new SpinnerNumberModel(new Integer(22), null, null, new Integer(1)));
		tbPort.setBounds(149, 51, 53, 20);
		panel.add(tbPort);
		
		JLabel lblUsername = new JLabel("Username:");
		lblUsername.setBounds(10, 82, 102, 14);
		panel.add(lblUsername);
		
		tbUsername = new JTextField();
		tbUsername.setText("user");
		tbUsername.setBounds(10, 98, 115, 20);
		panel.add(tbUsername);
		tbUsername.setColumns(10);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(10, 129, 78, 14);
		panel.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(10, 146, 115, 20);
		panel.add(tbPassword);
		tbPassword.setColumns(10);
		
		JLabel lblForwardSettings = new JLabel("Forward Settings");
		lblForwardSettings.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		lblForwardSettings.setHorizontalAlignment(SwingConstants.CENTER);
		lblForwardSettings.setBounds(10, 191, 192, 14);
		panel.add(lblForwardSettings);
		
		JLabel lblLocalPort = new JLabel("Local Port");
		lblLocalPort.setBounds(10, 216, 129, 14);
		panel.add(lblLocalPort);
		
		JSpinner tbLocalPort = new JSpinner();
		tbLocalPort.setModel(new SpinnerNumberModel(new Integer(5001), null, null, new Integer(1)));
		tbLocalPort.setBounds(10, 236, 63, 20);
		panel.add(tbLocalPort);
		
		JLabel lblRemoteHostAnd = new JLabel("Remote host and port");
		lblRemoteHostAnd.setBounds(10, 267, 129, 14);
		panel.add(lblRemoteHostAnd);
		
		tbRemoteHost = new JTextField();
		tbRemoteHost.setText("127.0.0.1");
		tbRemoteHost.setColumns(10);
		tbRemoteHost.setBounds(10, 283, 115, 20);
		panel.add(tbRemoteHost);
		
		tbRemotePort = new JSpinner();
		tbRemotePort.setModel(new SpinnerNumberModel(new Integer(5001), null, null, new Integer(1)));
		tbRemotePort.setBounds(149, 283, 53, 20);
		panel.add(tbRemotePort);
		
		btnStart = new JButton("Start");
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				startClick();
			}
		});
		btnStart.setBounds(63, 327, 89, 23);
		panel.add(btnStart);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBounds(234, 0, 519, 487);
		getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		scrollPane.setBounds(0, 401, 519, 86);
		panel_1.add(scrollPane);
		
		tableLog = new JTable(new LogTableModel());
		tableLog.setFillsViewportHeight(true);
		scrollPane.setViewportView(tableLog);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		scrollPane_1.setBounds(0, 0, 519, 400);
		panel_1.add(scrollPane_1);
		
		table = new JTable(new ConTableModel());
		TableColumn col = table.getColumnModel().getColumn(ConTableModel.ICON_INDEX);
		col.setCellRenderer(new ConTableCellRenderer());
		table.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(table);
		
		init();
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");		
	}

	protected void startClick() {
		if (session == null) 
		{
			btnStart.setText("Stop");
			session = new SshSession(this);
			session.setSshHost(tbHost.getText());
			session.setSshPort((Integer)tbPort.getValue());
			session.setForwardPort((Integer)tbPort.getValue());
			session.setForwardToHost(tbRemoteHost.getText());
			session.setForwardToPort((Integer)tbRemotePort.getValue());
			session.setUsername(tbUsername.getText());
			session.setPassword(new String(tbPassword.getPassword()));
			
			session.Connect();
		} 
		else 
		{
			btnStart.setText("Start");
			session.Disconnect();
			session = null;
		}
	}

	public void OnConnectionAdd(SshSession s, SshForwarding c) {
		ConTableModel model = (ConTableModel)table.getModel();
		model.addRow(c);
	}

	public void OnConnectionRemove(SshSession s, SshForwarding c) {
		ConTableModel model = (ConTableModel)table.getModel();
		model.remove(c);
	}

	public void OnConnectionChange(SshSession s, SshForwarding c) {
		ConTableModel model = (ConTableModel)table.getModel();
		model.change(c);
	}

	public void OnLog(Object sender, String s, boolean error) {
		LogTableModel model = (LogTableModel)tableLog.getModel();
		model.addRow(new Date(), s, error ? "E" : "I");
	}
}
