import java.util.Vector;
import javax.swing.table.AbstractTableModel;

public class UserTableModel extends AbstractTableModel {

	public static final int USER_INDEX = 0;
    public static final int AUTH_INDEX = 1;
    
	private static final long serialVersionUID = 1L;
    protected String[] columnNames = {"Username", "Authentication types" };
    protected Vector<UserDataRow> dataVector = new Vector<UserDataRow>();
    
 	public String getColumnName(int column) {
        return columnNames[column];
    }
 	
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
        return dataVector.size();
	}

	public Object getValueAt(int row, int col) {
        UserDataRow record = (UserDataRow)dataVector.get(row);
        switch (col) {
            case USER_INDEX:
               return record.Name;
            case AUTH_INDEX:
               return record.AuthType;
            default:
               return new Object();
        }
	}

 	public Class<?> getColumnClass(int column) {
        switch (column) {
            case USER_INDEX:
            case AUTH_INDEX:
            	return String.class;
            default:
               return Object.class;
        }
    }
 	
    public void setValueAt(Object value, int row, int column) {
   	 UserDataRow record = (UserDataRow)dataVector.get(row);
        switch (column) {
            case USER_INDEX:
               record.Name = (String)value;
               break;
            case AUTH_INDEX:
               record.AuthType = (String)value;
               break;
            default:
               System.out.println("invalid index");
        }
        fireTableCellUpdated(row, column);
    } 	
    
 	public void addRow(UserInfo user){
		dataVector.add(new UserDataRow(user)); 			
		fireTableDataChanged();
 	}

	public int getUserUNumber(int selectedRow) {
		return ((UserInfo)dataVector.get(selectedRow).Tag).getUNumber();
	}

	public void clear() {
		dataVector.clear();
	}
}
