import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.FileInputStream;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JRadioButton;

import SecureBlackbox.Base.TElWinCertStorage;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.PGP.TElPGPSecretKey;
import SecureBlackbox.XMLSecurity.TElXMLKeyInfoData;
import SecureBlackbox.XMLSecurity.TElXMLKeyInfoPGPData;
import SecureBlackbox.XMLSecurity.TElXMLKeyInfoRSAData;
import SecureBlackbox.XMLSecurity.TElXMLKeyInfoX509Data;
import SecureBlackbox.XMLSecurity.TElXMLSOAPBaseSignatureHandler;
import SecureBlackbox.XMLSecurity.TElXMLWSSSignatureHandler;
import SecureBlackbox.XMLSecurity.TSBXMLWSSEmbedCertificate;

public class SignatureHandlerFinalOptionsFrm extends JDialog {

	private final JPanel contentPanel = new JPanel();
	
	private boolean isOk;
	private JTextField edKeyName;
	private JTextField edKeyFile;
	private JTextField edPassphrase;
	private JRadioButton rbKeyFile;
	private JComboBox<String> cmbCertEmbed;
	private JCheckBox cbIncludeKey;
	private JComboBox cbCerts;
	private JRadioButton rbWinStore;
	
	private XAdESDialog xadesDialog;
	
	private TElWinCertStorage certStore = new TElWinCertStorage();

	/**
	 * Create the dialog.
	 */
	public SignatureHandlerFinalOptionsFrm() {
		setTitle("Signature Handler Options");
		setBounds(100, 100, 336, 408);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JButton btnXadesOptions = new JButton("XAdES Options...");
			btnXadesOptions.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					xadesDialog = new XAdESDialog();
					xadesDialog.setModal(true);
					xadesDialog.setVisible(true);
				}
			});
			btnXadesOptions.setBounds(159, 8, 142, 23);
			contentPanel.add(btnXadesOptions);
		}
		{
			JLabel lblNewLabel = new JLabel("Embed Certificate option:");
			lblNewLabel.setBounds(10, 15, 142, 14);
			contentPanel.add(lblNewLabel);
		}
		{
			cmbCertEmbed = new JComboBox<String>();
			cmbCertEmbed.setModel(new DefaultComboBoxModel<String>(new String[] {"In Signature", "In Binary Security Token", "In Signed Binary Security Token,", "In Binary Security Token And Signature", "None"}));
			cmbCertEmbed.setBounds(10, 40, 291, 23);
			contentPanel.add(cmbCertEmbed);
		}
		{
			cbIncludeKey = new JCheckBox("Include Key (public part)");
			cbIncludeKey.setBounds(6, 70, 295, 23);
			contentPanel.add(cbIncludeKey);
		}
		
		JLabel lblNewLabel_1 = new JLabel("Key Name:");
		lblNewLabel_1.setBounds(10, 101, 79, 14);
		contentPanel.add(lblNewLabel_1);
		
		edKeyName = new JTextField();
		edKeyName.setBounds(82, 98, 219, 20);
		contentPanel.add(edKeyName);
		edKeyName.setColumns(10);
		
		rbKeyFile = new JRadioButton("Use Key/Certificate from file:");
		rbKeyFile.setBounds(10, 138, 291, 23);
		contentPanel.add(rbKeyFile);
		
		edKeyFile = new JTextField();
		edKeyFile.setBounds(20, 170, 245, 20);
		contentPanel.add(edKeyFile);
		edKeyFile.setColumns(10);
		
		JButton btnNewButton = new JButton("...");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doChooseCertFile();
			}
		});
		btnNewButton.setBounds(275, 168, 26, 23);
		contentPanel.add(btnNewButton);
		
		JLabel lblNewLabel_2 = new JLabel("Key/Certificate password:");
		lblNewLabel_2.setBounds(20, 201, 211, 14);
		contentPanel.add(lblNewLabel_2);
		
		edPassphrase = new JTextField();
		edPassphrase.setBounds(20, 226, 281, 20);
		contentPanel.add(edPassphrase);
		edPassphrase.setColumns(10);
		
		rbWinStore = new JRadioButton("Use Certificate from Windows store:");
		rbWinStore.setBounds(10, 263, 291, 23);
		contentPanel.add(rbWinStore);
		
		cbCerts = new JComboBox();
		cbCerts.setBounds(20, 293, 281, 20);
		contentPanel.add(cbCerts);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Sign");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		rbKeyFile.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				rbWinStore.setSelected( ! rbKeyFile.isSelected());
			}
		});
		rbWinStore.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				rbKeyFile.setSelected( ! rbWinStore.isSelected());
			}
		});
		
		// ==================
		
		certStore.getSystemStores().clear();
		certStore.getSystemStores().add("MY");
		
		for (int i = 0; i < certStore.getCount(); i++) {
			cbCerts.addItem(certStore.getCertificate(i).getSubjectName().CommonName);
		}
	}
	
	public void init(TElXMLSOAPBaseSignatureHandler handler) {
		boolean vis = (handler instanceof TElXMLWSSSignatureHandler);
		cmbCertEmbed.setVisible(vis);
		cbIncludeKey.setVisible( ! vis);
	}
	
	public void applyOptions(TElXMLSOAPBaseSignatureHandler handler) {
		handler.setKeyName(getKeyName());
	}
	
	public TSBXMLWSSEmbedCertificate getEmbedCertificate() {
		TSBXMLWSSEmbedCertificate res = TSBXMLWSSEmbedCertificate.wecNone;
		
		switch (cmbCertEmbed.getSelectedIndex()) {
		case 0:
			res = TSBXMLWSSEmbedCertificate.wecInSignature;
			break;
		case 1:
			res = TSBXMLWSSEmbedCertificate.wecInBinarySecurityToken;
			break;
		case 2:
			res = TSBXMLWSSEmbedCertificate.wecInSignedBinarySecurityToken;
			break;
		case 3:
			res = TSBXMLWSSEmbedCertificate.wecInBinarySecurityTokenAndSignature;
			break;
		}
		
		return res;
	}
	
	public boolean getIncludeKey() {
		return cbIncludeKey.isSelected();
	}
	
	public String getKeyFile() {
		return edKeyFile.getText();
	}
	
	public String getKeyName() {
		return edKeyName.getText();
	}
	
	public String getPassphrase() {
		return edPassphrase.getText();
	}
	
	public TElX509Certificate getSigningCertificate() {
		if (rbKeyFile.isSelected()) {
			TElX509Certificate cert = new TElX509Certificate();
			int k = cert.loadFromFileAuto(getKeyFile(), getPassphrase());
			if (k == 0)
				return cert;
			else
				showMessage("Failed to load certificate. Error code: " + k);
		} else if (rbWinStore.isSelected()) {
			return certStore.getCertificate(cbCerts.getSelectedIndex());
		}
		
		return null;
	}
	
	public TElXMLKeyInfoData getKeyData() {
		TElX509Certificate cert = getSigningCertificate();
		if (cert != null) {
			if ( ! cert.getPrivateKeyExists())
				throw new RuntimeException("The selected certificate doesn''t contain a private key.");
			
			TElXMLKeyInfoX509Data x509KeyData = new TElXMLKeyInfoX509Data();
			x509KeyData.setCertificate(cert);
			
			return x509KeyData;
		}
		
		// trying to load file as RSA key material
		TElXMLKeyInfoRSAData rsaKeyData = new TElXMLKeyInfoRSAData(true);
		try {
			FileInputStream fs = new FileInputStream(getKeyFile());	
			try {
				rsaKeyData.getRSAKeyMaterial().setPassphrase(getPassphrase());
				rsaKeyData.getRSAKeyMaterial().loadSecret(fs, 0);
			} finally {
				fs.close();
			}
		} catch (Exception ex) {
			;
		}
		
		if (rsaKeyData.getRSAKeyMaterial().getSecretKey())
			return rsaKeyData;
		
		TElXMLKeyInfoPGPData pgpKeyData = new TElXMLKeyInfoPGPData(true);
		try {
			pgpKeyData.setSecretKey(new TElPGPSecretKey());
			pgpKeyData.getSecretKey().setPassphrase(getPassphrase());
			((TElPGPSecretKey)pgpKeyData.getSecretKey()).loadFromFile(getKeyFile());
		} catch (Exception ex) {
			;
		}
		
		if (pgpKeyData.getSecretKey() != null)
			return pgpKeyData;
		
		throw new RuntimeException("Failed to load a Key/Certificate.");
	}

	public boolean isOK() {
		return isOk;
	}
	
	public XAdESDialog getXAdESDialog() {
		return xadesDialog;
	}
	
	private void doChooseCertFile() {
		edKeyFile.setText(getFileName());
	}
	
	private void showMessage(String msg) {
    	JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}
	
	private String getFileName() {
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
}
