

import java.awt.EventQueue;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import SecureBlackbox.Base.*;
import SecureBlackbox.ZIP.*;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import org.freepascal.rtl.TObject;

import java.awt.BorderLayout;
import java.io.File;

public class Main {

	private JFrame frmZipArchivier;
	private JTable table;

	String currentPath;
	String extractToPath;
	TElZipWriter elZipWriter;

	JMenuItem mnCloseArchive;
	JMenuItem mntmSaveArchive;
	JMenuItem mntmSaveArchiveAs;
	private JLabel lblCurrentPath;
	String newArchiveName;
	String openedArchiveName;

	ProgressDialog progressForm;	
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frmZipArchivier.setVisible(true);
				} catch (Exception e) {
					showErrorMessage("Error", e.getMessage());
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
		initZipWriterEvents();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

 		SBChSConv.initialize();
 		SBChSConvCharsets.initialize();
		
		elZipWriter = new TElZipWriter();

		frmZipArchivier = new JFrame();
		frmZipArchivier.setTitle("ZIP Archivier");
		frmZipArchivier.setBounds(100, 100, 450, 300);
		frmZipArchivier.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JMenuBar menuBar = new JMenuBar();
		frmZipArchivier.setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmOpenArchive = new JMenuItem("Open archive...");
		mntmOpenArchive.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				openArchive();
			}
		});
		mnFile.add(mntmOpenArchive);
		
		JMenuItem mntmNewArchive = new JMenuItem("New archive...");
		mntmNewArchive.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				newArchive();
			}
		});
		mnFile.add(mntmNewArchive);
		
		mnCloseArchive = new JMenuItem("Close archive");
		mnCloseArchive.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				closeArchive();
			}
		});
		mnCloseArchive.setEnabled(false);
		mnFile.add(mnCloseArchive);
		
		mntmSaveArchive = new JMenuItem("Save archive");
		mntmSaveArchive.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveArchive();
			}
		});
		mntmSaveArchive.setEnabled(false);
		mnFile.add(mntmSaveArchive);
		

		mntmSaveArchiveAs = new JMenuItem("Save archive as...");
		mntmSaveArchiveAs.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveArchiveAs();
			}
		});
		mntmSaveArchiveAs.setEnabled(false);
		mnFile.add(mntmSaveArchiveAs);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				frmZipArchivier.dispose();
			}
		});
		mnFile.add(mntmExit);
		
		table = new JTable();
		JScrollPane scrollPane = new JScrollPane(table); 
		frmZipArchivier.getContentPane().add(scrollPane, BorderLayout.CENTER);
		
		lblCurrentPath = new JLabel(" ");
		frmZipArchivier.getContentPane().add(lblCurrentPath, BorderLayout.SOUTH);
		
		initPopup();
		initDoubleClick();
	}

	private void initDoubleClick() {
		table.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e){
			      if (e.getClickCount() == 2){
			    	  openItem();
			      }
			}
		});
	}

	private void openItem() {
		if (table.getSelectedRowCount() > 0){
			TElZipArchiveDirectoryEntry entry = ((KeyTableModel)table.getModel()).getFirstSelectedItem(table.getSelectedRow());
			
			if (entry == null)
				currentPath = SBStrUtils.pathCutLastComponent(currentPath);
			else if (entry.getIsDirectory())
				currentPath = entry.getPath();
			else
				return;

			refreshFilesList();			
		}
	}
	
	private void initPopup() {
        JPopupMenu popup = new JPopupMenu();  
        JMenuItem popupExtract = new JMenuItem("Extract");  
        JMenuItem popupExtractTo = new JMenuItem("Extract to...");
        JMenuItem popupAddFiles = new JMenuItem("Add files...");
        JMenuItem popupAddDirectory = new JMenuItem("Add directory...");
        JMenuItem popupDelete = new JMenuItem("Delete");
        JMenuItem popupValidateSign = new JMenuItem("Validate signature");
        JMenuItem popupValidateDirSign = new JMenuItem("Validate dir signature");
        
        popupExtract.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				extractSelectedFiles(SBStrUtils.pathCutLastComponent(openedArchiveName));				
			}
		});

        popupExtractTo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String directory = selectDirectory();
				extractSelectedFiles(directory);
			}
		});
        
        popupAddFiles.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addFilesToArchive();
			}
		});
        
        popupAddDirectory.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String directory = selectDirectory();
				TElZipArchiveDirectoryEntry entry;
				entry = elZipWriter.getDirectory().entryWithPath(currentPath);
				if (entry == null)
					entry = elZipWriter.getDirectory();
				elZipWriter.add(entry, directory);
				refreshFilesList();				
			}
		});

        popupDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				((KeyTableModel)table.getModel()).removeSelectedItems(table.getSelectedRows());
			}
		});
        
        popupValidateSign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
	            String st;
	            boolean Valid;
	            TElZipArchiveDirectoryEntry entry;
	            TElRDNConverter converter = new TElRDNConverter();

	            entry = ((KeyTableModel)table.getModel()).getFirstSelectedItem(table.getSelectedRow());
	            st = "";

	            for (int i = 0; i < entry.getSignatureCount(); i++)
	            {
	                st = st + "Signature #" + i + ":\n";

	                try
	                {
	                    Valid = elZipWriter.validateSignature(entry, i);
	                    if (Valid)
	                        st = st + "Signature is valid\n";
	                    else
	                        st = st + "INVALID signature!\n";
	                    st = st + converter.saveToDNString(entry.getSignature(i).getSigningCertificate().getSubjectRDN()) + "\n";
	                }
	                catch (Exception ex)
	                {
	                    st = st + ex.getMessage() + "\n";
	                }                 
	            }

	            showMessage("Signature(s) validation result", st);			
			}
		});
        
        popupValidateDirSign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
	            String st = "Central directory signature:\n";
	            TElRDNConverter converter = new TElRDNConverter();
	    
	            try
	            {
	                boolean Valid = elZipWriter.validateDirectorySignature();
	                if (Valid)
	                    st = st + "Signature is valid\n";
	                else
	                    st = st + "INVALID signature!\n";
	                st = st + converter.saveToDNString(elZipWriter.getDirectory().getSignature(0).getSigningCertificate().getSubjectRDN()) + "\n";
	            }
	            catch (Exception ex)
	            {
	                st = st + ex.getMessage() + "\n";
	            }

	            showMessage("Signature(s) validation result", st);				
			}
		});
        
        popup.add(popupExtract);  
        popup.add(popupExtractTo);  
        popup.add(popupAddFiles);
        popup.add(popupAddDirectory);
        popup.add(popupDelete);
        popup.add(popupValidateSign);
        popup.add(popupValidateDirSign);
        
        MouseListener listener=new TablePopupListener(popup, table);  
        table.addMouseListener(listener);  
	}

	private void initZipWriterEvents() {
		elZipWriter.setOnUserActionNeeded(new TSBZipUserActionNeededEvent(actionClbk));
		elZipWriter.setOnCompressionFinished(new TSBZipCompressionFinishedEvent(finishClbk));
		elZipWriter.setOnPrivateKeyNeeded(new TSBZipPrivateKeyNeededEvent(privKeyNeededClbk));
		elZipWriter.setOnCompressionStart(new TSBZipCompressionStartEvent(compressionStartClbk));
		elZipWriter.setOnPasswordNeeded(new TSBZipPasswordNeededEvent(passwNeededClbk));
		elZipWriter.setOnExtractionFinished(new TSBZipExtractionFinishedEvent(extrClbk));
		elZipWriter.setOnProgress(new TSBZipProgressEvent(progressClbk));
		elZipWriter.setOnExtractionStart(new TSBZipExtractionStartEvent(extrStartClbk));
	}

	private void addFilesToArchive() {
		File[] files = getFileNames();
		for (int i = 0; i < files.length; i++)
			elZipWriter.add(elZipWriter.getDirectory(), files[i].getPath());
		refreshFilesList();
	}
	
	private String selectDirectory() {
		JFileChooser fc = new JFileChooser(); 
	    fc.setCurrentDirectory(new java.io.File("."));
	    fc.setDialogTitle("Select directory to extract files to");
	    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	    fc.setAcceptAllFileFilterUsed(false);

	    if (fc.showOpenDialog(frmZipArchivier) == JFileChooser.APPROVE_OPTION)
	    	return fc.getSelectedFile().getPath();
	    
	    return "";
	}

	private File[] getFileNames() {
		JFileChooser chooser = new JFileChooser();
		chooser.setDialogTitle("Add files to archive...");
		chooser.setMultiSelectionEnabled(true);

		chooser.showOpenDialog(frmZipArchivier);

		return chooser.getSelectedFiles();			
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(frmZipArchivier);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 

	String getFileSaveAsName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(frmZipArchivier);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	private void openArchive() {
		if (elZipWriter.getOpened())
			elZipWriter.close();

		String fileName = getFileName();
		if (fileName.length() > 0)
		{
			openedArchiveName = fileName;
			try
			{
				elZipWriter.open(fileName, false);
			}
			catch (Exception ex)
			{
				showErrorMessage("Error opening archive", ex.getMessage());
			}

			if (elZipWriter.getOpened())
			{
				currentPath = "";
				mnCloseArchive.setEnabled(true);
				mntmSaveArchive.setEnabled(true);
				mntmSaveArchiveAs.setEnabled(true);
				
				refreshFilesList();
			}
			else
			{
				mnCloseArchive.setEnabled(false);
			}
		}
	}

	static void showErrorMessage(String caption, String msg){
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.ERROR_MESSAGE);
	}
	
	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	
	
	private void closeArchive() {
		if (elZipWriter.getOpened())
		{
			elZipWriter.close();
			clearTable();
			mnCloseArchive.setEnabled(false);
		}
	}

	private void refreshFilesList()
	{
		if (!elZipWriter.getOpened())
			return;
	
		clearTable();

		table.setModel(new KeyTableModel(elZipWriter, currentPath));
		
		lblCurrentPath.setText(currentPath);
	}

	private void clearTable() {
		Object model = table.getModel();
		if (model instanceof KeyTableModel)
		{
			((KeyTableModel) model).dataVector.removeAllElements();
			((KeyTableModel) model).fireTableDataChanged();
		}
		else
			((DefaultTableModel) model).setNumRows(0);
	}

	private void createNewArchive(ArchiveOptionsDialog src) {
		newArchiveName = src.getNewArchiveFullPath();
		
		elZipWriter.createArchive();

		elZipWriter.setCompressionAlgorithm(src.getCompressionAlg());
		elZipWriter.setCompressionLevel(src.getCompressionLevel());
		elZipWriter.setDirectoryCompressed(src.getIsDirCompressed());

		elZipWriter.setEncrypt(src.getIsEncrypt());
		
		if (elZipWriter.getEncrypt()) {
			int index = src.getEncryptionIndex();
			if (index == 1)
			{
				elZipWriter.setStrongEncryption(false);
				elZipWriter.setWinZipEncryption(false);
			}
			else if (index == 2)
			{
				elZipWriter.setStrongEncryption(false);
				elZipWriter.setWinZipEncryption(true);
				elZipWriter.setWinZipAesKeySize(src.getWinZipAesKeySize());
			}
			else if (index == 3)
			{
				elZipWriter.setStrongEncryption(true);
				elZipWriter.setWinZipEncryption(false);

				elZipWriter.getStrongEncryptionInfo().setEncryptionAlgorithm(src.getEncryptionAlg());

				elZipWriter.setDirectoryEncrypted(src.getIsDirEncrypt());
				if (elZipWriter.getDirectoryEncrypted())
					elZipWriter.setDirectoryCompressed(true);
			}

			elZipWriter.setPassword(src.getPassword());
		}

		mnCloseArchive.setEnabled(true);
		mntmSaveArchive.setEnabled(true);
		mntmSaveArchiveAs.setEnabled(true);
		currentPath = "";
		
		addFilesToArchive();	
		
	}

	private void newArchive() {
		
		closeArchive();
		
		ArchiveOptionsDialog dlg = new ArchiveOptionsDialog();
		dlg.setModal(true);
		dlg.setVisible(true);
		if (dlg.getIsCreateArch())
			createNewArchive(dlg);
	}

	private void saveArchiveAs() {
		newArchiveName = getFileSaveAsName();
		saveArchive();
	}
	
	private void saveArchive() {
		
		progressForm = new ProgressDialog();

		progressForm.setCaptionText("Compressing...");
		progressForm.setButtonOKEnabled(false);
		progressForm.setButtonCancelEnabled(true);
		progressForm.setCancelOperation(false);
		
		progressForm.setVisible(true);
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try
				{
					if (elZipWriter.getNewArchive())
			            elZipWriter.compress(newArchiveName);
			        else
			           elZipWriter.compress();
				}
				catch (Exception ex)
				{
					showErrorMessage("Compression error", ex.getMessage());
				}
				finally
				{
					progressForm.setButtonCancelEnabled(false);
					progressForm.setButtonOKEnabled(true);
				}
				refreshFilesList();							
			}
		});
		
		t.start();
	}
	

	private void extractSelectedFiles(String outputPath)
	{
		progressForm = new ProgressDialog();
		progressForm.setButtonOKEnabled(false);
		progressForm.setButtonCancelEnabled(true);
		progressForm.setCancelOperation(false);
		progressForm.clearLog();
		progressForm.setCaptionText("Extracting...");
		progressForm.setVisible(true);
		
		extractToPath = outputPath;
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try
				{
					ArrayList list = ((KeyTableModel)table.getModel()).getSelectedItems(table.getSelectedRows());
					elZipWriter.extract(list, extractToPath);
				}
				catch (Exception ex)
				{
					progressForm.addToLog("Error extracting file: " + ex.getMessage());                
				}
				finally
				{
					progressForm.setButtonCancelEnabled(false);
					progressForm.setButtonOKEnabled(true);
				}
			}
		});
		
		t.start();
	}

	private int selectUserAction(String description) {
		int result = JOptionPane.showOptionDialog(null, description, "Warning", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, new String[] { "Abort", "Retry", "Ignore" }, null);
		
		if (result == 0)
			return SBArcZip.ZIP_ACTION_ABORT;
		else if (result == 1)
			return SBArcZip.ZIP_ACTION_RETRY;

		return SBArcZip.ZIP_ACTION_IGNORE;
	}
	
	// events
	
	TSBZipUserActionNeededEvent.Callback actionClbk = new TSBZipUserActionNeededEvent.Callback() {		
		public void tsbZipUserActionNeededEventCallback(TObject sender, int forEvent, String description, TObject param, TSBInteger action) {
			action.value = selectUserAction(description);
		}
	};
	
	TSBZipCompressionFinishedEvent.Callback finishClbk = new TSBZipCompressionFinishedEvent.Callback() {
		public void tsbZipCompressionFinishedEventCallback(TObject sender, TElZipArchiveDirectoryEntry entry) {
			if (!entry.getIsDirectory())
				progressForm.addToLog("File compressed : " + entry.getFileName());
		}
	};
	
	TElX509Certificate getCertificateValue(){
		CertificateDialog certificateForm = new CertificateDialog();
		certificateForm.setModal(true);
		certificateForm.setVisible(true);
		return certificateForm.getX509Certificate();
	}
	TSBZipPrivateKeyNeededEvent.Callback privKeyNeededClbk = new TSBZipPrivateKeyNeededEvent.Callback() {
		public void tsbZipPrivateKeyNeededEventCallback(TObject sender, TObject param, TElX509Certificate cert) {
			TElX509Certificate c = getCertificateValue();
			c.clone(cert, true);
		}
	};
	
	TSBZipCompressionStartEvent.Callback compressionStartClbk = new TSBZipCompressionStartEvent.Callback() {
		public void tsbZipCompressionStartEventCallback(TObject sender, TElZipArchiveDirectoryEntry entry, TSBBoolean allow) {
			progressForm.setCurrentFileName(entry.getPath());
			progressForm.setProgressBarCurrentFile(0);
			allow.value = true;
		}
	};
	
	TSBZipPasswordNeededEvent.Callback passwNeededClbk = new TSBZipPasswordNeededEvent.Callback() {
		public void tsbZipPasswordNeededEventCallback(TObject sender, TObject param, TSBString pass, TSBBoolean accept) {
			JPasswordField jpf = new JPasswordField();
			int result = JOptionPane.showConfirmDialog(null, jpf, "Passphrase is needed for secret key", JOptionPane.OK_CANCEL_OPTION);
			if (result == 0)
			{
				pass.value = new String(jpf.getPassword());
				accept.value = false;
			} else { 
 
			pass.value = "";
			accept.value = true;
			}
		}
	};
	
	TSBZipExtractionFinishedEvent.Callback extrClbk = new TSBZipExtractionFinishedEvent.Callback() {
		public void tsbZipExtractionFinishedEventCallback(TObject sender, TElZipArchiveDirectoryEntry entry) {
			if (!entry.getIsDirectory())
				progressForm.addToLog("File extracted : " + entry.getFileName());
		}
	}; 
	
	TSBZipProgressEvent.Callback progressClbk = new TSBZipProgressEvent.Callback() {
		public void tsbZipProgressEventCallback(TObject sender, long processed, long total, long overallProcessed, long overallTotal, TSBBoolean cancel) {
			long processedNorm;
            if (total > 0)
                processedNorm = ((processed * 100000) / total);
            else
                processedNorm = 100000;
			progressForm.setProgressBarCurrentFile((int) processedNorm);
            if (overallTotal > 0)
                processedNorm = (overallProcessed * 100000 / overallTotal);
            else
                processedNorm = 100000;
			progressForm.setProgressBarTotal((int) processedNorm);
			cancel.value = progressForm.getCancelOperation();
		}
	};
	
	TSBZipExtractionStartEvent.Callback extrStartClbk = new TSBZipExtractionStartEvent.Callback() {
		public void tsbZipExtractionStartEventCallback(TObject sender, TElZipArchiveDirectoryEntry entry, TSBBoolean allow) {
			progressForm.setCurrentFileName(entry.getPath());
			progressForm.setProgressBarCurrentFile(0);
			allow.value = true;
		}
	};
}